#!/usr/bin/perl -w


use MIME::Base64;


$usage = "makebasicbase64.perl program.prg\n";


$prg = shift || die $usage;
$txt = shift || die $usage;
shift && die $usage;


sub readbyte($) {
  my $fh = shift;
  my $data;

  read($fh, $data, 1) || return;
  return(ord($data));
}


$quadsum = 0;
$endadjust = 0;

sub readquad($) {
  my $fh = shift;
  my $data;
  my $len;
  my $b;

  $len = read($fh, $data, 3);
  if ($len <= 0) {
    return 0;
  }
  $endadjust = 3 - $len;
  $quadsum = 0;
  foreach $b (split(//, $data)) {
    $quadsum += ord($b);
  }
  $b64 = encode_base64("$data");
  $b64 =~ tr#A-Za-z0-9+/=#./0-9a-zA-Z.#;
  $b64 =~ tr#lO#:-#;
  chomp($b64);
  return($b64);
}


open(PRG, $prg) || die "Couldn't open $prg: $!\n";

if (readbyte(PRG) ne 0) {
  die "Program must start on page boundary\n";
}
$la = readbyte(PRG) * 256;
$line = 1;
$w = 0;
$sum = $line;

$out = "  0 a=$la : sa=a : goto 100\n";

while ($q = readquad(PRG)) {
  if ($w == 0) {
    $out .= sprintf("%3s data \"", $line);
  }
  $out .= $q;
  $sum += $quadsum;
  if (++$w == 6) {
    $out .= sprintf("\",%d\n", $sum & 0xff);
    ++$line;
    $sum = ($sum + $line) & 0xff;
    $w = 0;
  }
}
if ($w) {
  $out .= sprintf("\",%d\n", $sum & 0xff);
}

$ipstart = 4 + $endadjust;
$ipend = 1 + $endadjust;

$out .= <<END;
 99 data end
100 n=n+1 : print n : c=c+n : read a\$ : if a\$<>"end" then read ck : goto 120
110 print "poke";a-$ipstart;"to";a-$ipend;"to set ip, sys";sa;"to start" : end
120 for i=1 to len(a\$) step 4 : q\$=mid\$(a\$,i,4) : gosub 200
130 for k=0 to 2 : poke a+k,q(k) : c=c+q(k) : next : a=a+3 : next
140 c=c and 255 : if c=ck then 100
150 print"checksum error" : end
200 for k=1 to 4 : q=asc(mid\$(q\$,k,1)) : gosub 300 : q(k)=q : next
210 q(0)=q(1)*4 + int(q(2)/16) : q(1)=(q(2)*16 + int(q(3)/4)) and 255
220 q(2)=(q(3)*64+q(4)) and 255 : return
300 if q=58 then q=23 : return
310 if q=45 then q=52 : return
320 if q>192 then q=q-155 : return
330 if q>64 then q=q-53 : return
340 q=q-46 : return
END

close(PRG);

open(TXT, ">$txt") || die "Couldn't save to $txt: $!\n";
print TXT $out;
close(TXT);
